import type { Knex } from 'knex';
import { Model } from 'objection';
import { PGDispatcher } from './dispatcher';
import type { ExLogger } from './types';
export interface CoreDBDispatcherOptions {
    healthcheckInterval?: number;
    healthcheckTimeout?: number;
    suppressStatusLogs?: boolean;
    beforeTerminate?: () => Promise<void>;
}
export interface CoreDBConstructorArgs {
    connectionString: string;
    dispatcherOptions?: CoreDBDispatcherOptions;
    knexOptions?: Knex.Config;
    logger?: ExLogger;
}
declare class CoreBaseModel extends Model {
    static set db(value: PGDispatcher);
    static get primary(): Knex<any, any[]>;
    get primary(): Knex<any, any[]>;
    static get replica(): Knex<any, any[]>;
    get replica(): Knex<any, any[]>;
}
export declare function initDB({ connectionString, dispatcherOptions, knexOptions, logger, }: CoreDBConstructorArgs): {
    db: PGDispatcher;
    CoreBaseModel: typeof CoreBaseModel;
    helpers: {
        clearDatabase: () => Promise<void>;
        rollbackDatabase: () => Promise<void>;
        migrateDatabase: () => Promise<void>;
        prepareDatabase: () => Promise<void>;
    };
};
export {};
