import type { Knex } from 'knex';
import type { ExLogger, PDOptions } from './types';
export interface PDConstructorArgs {
    connections: string[];
    options: PDOptions;
    knexOptions?: Knex.Config;
    logger: ExLogger;
}
export declare class PDError extends Error {
    code?: string;
}
export declare class PGDispatcher {
    knexOptions: Knex.Config;
    private connections;
    private options;
    private logger;
    private hcTimer?;
    private isInit;
    constructor({ connections, options, knexOptions, logger }: PDConstructorArgs);
    get knexConfig(): Knex.Config<any>;
    ready(): Promise<void>;
    terminate(): Promise<void[]>;
    get primary(): Knex<any, any[]>;
    get replica(): Knex<any, any[]>;
    private initHealthcheck;
    private performCheckupQuery;
    private checkDatabase;
    private knexReady;
    private get healthyConnections();
    private checkConnectionsAvailability;
}
